=== debian/changelog ===
ply-probe (2.3.0.25.gec815ed-1) unstable; urgency=medium

  * Initial release. (Closes: #1091862)

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Tue, 14 Jan 2025 19:58:04 +0000
