## ply-probe 2.4.0

=== test/Makefile ===
--- 
+++ 
@@ -25,7 +25,7 @@
 	-nographic -no-reboot \
 	-kernel work/$(1)-rootfs/boot/vmlinuz-virt \
 	-initrd work/$(1)-rootfs.cpio.gz \
-	-watchdog i6300esb \
+	-device i6300esb \
 	-append "$(2) panic=-1 root=initramfs ramdisk_size=64000 rdinit=/sbin/init quiet"
 
 qemu-armv7 = qemu-system-arm -M virt,highmem=off \
