=== debian/changelog ===
ply-probe (2.4.0-1) unstable; urgency=medium

  * New upstream version 2.4.0

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Mon, 24 Feb 2025 11:39:55 +0000
