=== debian/control ===
Source: ply-probe
Section: admin
Priority: optional
Maintainer: Sudip Mukherjee <sudipm.mukherjee@gmail.com>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 bison,
 flex,
 ronn
Standards-Version: 4.7.0
Homepage: https://wkz.github.io/ply/
Vcs-Browser: https://salsa.debian.org/sudip/ply-probe
Vcs-Git: https://salsa.debian.org/sudip/ply-probe.git

Package: ply
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: Light-weight dynamic tracer for Linux
 A light-weight dynamic tracer for Linux that leverages the kernel's BPF
 VM in concert with kprobes and tracepoints to attach probes to arbitrary
 points in the kernel.
 .
 ply follows the Little Language approach of yore, compiling ply scripts
 into Linux BPF programs that are attached to kprobes and tracepoints in
 the kernel.
