=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE = 1

%:
	dh $@

override_dh_auto_install:
	dh_auto_install
	# do not install .la, .a and header files
	rm -f debian/ply/usr/lib/*/*.la debian/ply/usr/lib/*/*.a \
	 debian/ply/usr/lib/*/*.so debian/ply/usr/share/doc/ply/COPYING
	rm -rf debian/ply/usr/include
