=== debian/watch ===
version=4

opts="mode=git, pretty=describe" \
    https://github.com/iovisor/ply.git HEAD \
    debian uupdate
